"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
function intercalate(separator, items) {
    var acc = [];
    items.forEach(function (x) {
        if (acc.length > 0)
            acc.push(separator);
        acc.push(x);
    });
    return immutable_1.List(acc);
}
exports.intercalate = intercalate;
function checkStringMap(x) {
    if (typeof x !== "object") {
        return panic("Value must be an object, but is " + x);
    }
    return x;
}
exports.checkStringMap = checkStringMap;
function checkArray(x) {
    if (!Array.isArray(x)) {
        return panic("Value must be an array, but is " + x);
    }
    return x;
}
exports.checkArray = checkArray;
function defined(x) {
    if (x !== undefined)
        return x;
    return panic("Defined value expected, but got undefined");
}
exports.defined = defined;
function nonNull(x) {
    if (x !== null)
        return x;
    return panic("Non-null value expected, but got null");
}
exports.nonNull = nonNull;
function assertNever(x) {
    throw new Error("Unexpected object: " + x);
}
exports.assertNever = assertNever;
function assert(condition, message) {
    if (message === void 0) { message = "Assertion failed"; }
    if (!condition) {
        throw Error(message);
    }
}
exports.assert = assert;
function panic(message) {
    throw Error(message);
}
exports.panic = panic;
exports.hashCodeInit = 17;
function addHashCode(acc, h) {
    return (acc * 31 + (h | 0)) | 0;
}
exports.addHashCode = addHashCode;
function repeated(n, value) {
    var arr = [];
    for (var i = 0; i < n; i++) {
        arr.push(value);
    }
    return arr;
}
exports.repeated = repeated;
function repeatedCall(n, producer) {
    var arr = [];
    for (var i = 0; i < n; i++) {
        arr.push(producer());
    }
    return arr;
}
exports.repeatedCall = repeatedCall;
function withDefault(x, theDefault) {
    if (x !== null && x !== undefined) {
        return x;
    }
    return theDefault;
}
exports.withDefault = withDefault;
