import { OrderedSet, Collection } from "immutable";
import { TypeAttributeKind, TypeAttributes } from "./TypeAttributes";
export declare type NameOrNames = string | TypeNames;
export declare class TypeNames {
    private readonly names;
    private readonly _alternativeNames;
    readonly areInferred: boolean;
    constructor(names: OrderedSet<string>, _alternativeNames: OrderedSet<string>, areInferred: boolean);
    add(names: TypeNames): TypeNames;
    clearInferred(): TypeNames;
    readonly combinedName: string;
    readonly proposedNames: OrderedSet<string>;
    makeInferred(): TypeNames;
    singularize(): TypeNames;
}
export declare function typeNamesUnion(c: Collection<any, TypeNames>): TypeNames;
export declare const namesTypeAttributeKind: TypeAttributeKind<TypeNames>;
export declare function modifyTypeNames(attributes: TypeAttributes, modifier: (tn: TypeNames | undefined) => TypeNames | undefined): TypeAttributes;
export declare function singularizeTypeNames(attributes: TypeAttributes): TypeAttributes;
export declare function makeNamesTypeAttributes(nameOrNames: NameOrNames, areNamesInferred?: boolean): TypeAttributes;
